// ContextMenu.h : Declaration of the CContextMenu

#pragma once
#include "resource.h"       // main symbols
#include "tbzrstructs.h"

typedef DWORD ARGB;

// CContextMenu

class CContextMenu :
    public IShellExtInit,
    public IContextMenu3
{
    LONG m_refcnt;
public:
	CContextMenu();

public:
	// Implementation, using exceptions to report failure.
	void DoInitialize(PCIDLIST_ABSOLUTE pidlFolder, IDataObject *pdtobj, HKEY hkeyProgID);
	UINT BuildFromRemoteItems(HMENU hmenu, UINT indexMenu, UINT idCmdFirst, const std::vector<TBZRMenuInfo> &items);
	HICON LoadHICON(const TBZRMenuInfo &item);
	HBITMAP IconToBitmapPARGB32(const TBZRMenuInfo &item);

    STDMETHODIMP QueryInterface(const IID &riid, void **ppv);
    TBZR_IUNKNOWN_IMPLEMENT();

	// IShellExtInit implementation
	STDMETHOD(Initialize)(PCIDLIST_ABSOLUTE pidlFolder, IDataObject *pdtobj, HKEY hkeyProgID);
	// IContextMenu
	STDMETHOD(QueryContextMenu)(HMENU hmenu, UINT indexMenu, UINT idCmdFirst, UINT idCmdLast, UINT uFlags);
	STDMETHOD(InvokeCommand)(CMINVOKECOMMANDINFO *pici);
	STDMETHOD(GetCommandString)(UINT_PTR idCmd, UINT uType, UINT *pReserved, LPSTR pszName, UINT cchMax);
	// IContextMenu2
	STDMETHOD(HandleMenuMsg)(UINT,WPARAM,LPARAM);
	// IContextMenu3
	STDMETHOD(HandleMenuMsg2)(UINT,WPARAM,LPARAM,LRESULT *);

	static UINT m_CF_SHELLIDLIST;
	std::vector<std::wstring> m_filenames;
	bool m_fileselected;
	std::map<UINT, TBZRMenuInfo> m_handlers;
	UINT m_idfirst; // our first ID as specified by our caller.

	WORD fullver; // Windows Version. see tortoisesvn.
	std::map<std::wstring, HBITMAP> bitmaps;
};
