// CopyHook.cpp : Implementation of CCopyHook

#include "stdafx.h"
#include "CopyHook.h"
#include "RemoteLink.h"


// CCopyHook

CCopyHook::CCopyHook() : m_refcnt(0)
{}

HRESULT CCopyHook::QueryInterface(const IID &riid, void **ppv)
{
    if (!ppv)
        return E_POINTER;

    *ppv = NULL;

    if (IsEqualIID(riid, IID_IShellExtInit) || IsEqualIID(riid, IID_IUnknown)) {
        *ppv = (LPSHELLEXTINIT) this;
    }
    else if (IsEqualIID(riid, IID_ICopyHookW)) {
        *ppv = (LPCOPYHOOKW) this;
    }

    if (*ppv) {
        AddRef();
        return NOERROR;
    }

    return E_NOINTERFACE;
}

// ICopyHook implementation
STDMETHODIMP_(UINT) CCopyHook::CopyCallback(
		HWND /*hwnd*/,
		UINT wFunc,
		UINT /*wFlags*/,
		LPCWSTR srcFile,
		DWORD /*srcAttribs*/,
		LPCWSTR /*destFile*/,
		DWORD /*destAttribs*/)
{
    if (wFunc == FO_COPY)
        return IDYES; // copying is not a problem for us
    try {
        CRemoteLink::GetLink()->RequestReleaseHandles(srcFile);
    }
    catch (TBzrException &e) {
        TBZR_ERROR("RequestReleaseHandles failed. %s\r\n", e.what());
    }
    // we could now wait a little bit to give the cache time to release the handles.
    // but the explorer/shell already retries any action for about two seconds
    // if it first fails. So if the cache hasn't released the handle yet, the explorer
    // will retry anyway, so we just leave here immediately.
    return IDYES;
}
