# this is a package
import _winreg
import pythoncom
from bzrlib.tests import Feature

def get_clsid_for_handler(handler_type):
    hroot = _winreg.HKEY_CLASSES_ROOT
    subkey_keyname = r"Directory\shellex\%sHandlers\TortoiseBazaar" % handler_type
    try:
        hk = _winreg.OpenKey(hroot, subkey_keyname)
        ret = _winreg.QueryValue(hk, None)
    except WindowsError:
        raise RuntimeError(
            "No handler of type '%s' seems to be registered" % handler_type)
    return ret


class _ShellExtensionFeature(Feature):
    def __init__(self, handler_type, *args, **kw):
        self.handler_type = handler_type
        super(_ShellExtensionFeature, self).__init__(*args, **kw)

    def _probe(self):
        try:
            clsid = get_clsid_for_handler(self.handler_type)
        except RuntimeError:
            return False
        try:
            pythoncom.CoCreateInstance(clsid, None, pythoncom.CLSCTX_ALL,
                                       pythoncom.IID_IUnknown)
        except pythoncom.com_error:
            return False
        return True

    def feature_name(self):
        return '%s Shell Extension' % self.handler_type
